## batmand 0.2

=== Makefile ===
#
# Copyright (C) 2006 BATMAN contributors
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of version 2 of the GNU General Public
# License as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA
#


CC =			gcc
CFLAGS =		-Wall -O1 -g3 -DDEBUG_MALLOC -DMEMORY_USAGE -DPROFILE_DATA
STRIP=			strip
LDFLAGS =		-lpthread -static

CFLAGS_MIPS =	-Wall -O1 -g3
LDFLAGS_MIPS =	-lpthread

UNAME=		$(shell uname)

ifeq ($(UNAME),Linux)
OS_C=	 linux-specific.c linux.c
endif

ifeq ($(UNAME),Darwin)
OS_C=	bsd.c
endif

ifeq ($(UNAME),FreeBSD)
OS_C=	bsd.c
endif

ifeq ($(UNAME),OpenBSD)
OS_C=	bsd.c
endif

LOG_BRANCH= branches/batman-0.2.x

LINUX_SRC_C= batman.c originator.c schedule.c posix-specific.c posix.c allocate.c bitarray.c hash.c profile.c $(OS_C)
LINUX_SRC_H= batman.h originator.h schedule.h batman-specific.h list.h os.h allocate.h bitarray.h hash.h profile.h 

BINARY_NAME=	batmand
SOURCE_VERSION_HEADER= batman.h

REVISION=		$(shell svn info | grep "Rev:" | sed -e '1p' -n | awk '{print $$4}')
REVISION_VERSION=	\"\ rv$(REVISION)\"
BUILD_PATH=		/home/batman/build
IPKG_BUILD_PATH=	$(BUILD_PATH)/ipkg-build

BAT_VERSION=		$(shell grep "^\#define SOURCE_VERSION " $(SOURCE_VERSION_HEADER) | sed -e '1p' -n | awk -F '"' '{print $$2}' | awk '{print $$1}')
IPKG_VERSION=		$(BAT_VERSION)-rv$(REVISION)
FILE_NAME=		$(BINARY_NAME)_$(BAT_VERSION)-rv$(REVISION)_$@
FILE_CURRENT=		$(BINARY_NAME)_$(BAT_VERSION)-current_$@

IPKG_DEPENDS=		"kmod-tun libpthread"


CC_MIPS_KK_BC_PATH =	/usr/src/openWrt/build/kamikaze-brcm63xx-2.6/kamikaze/staging_dir_mipsel/bin
CC_MIPS_KK_BC =		$(CC_MIPS_KK_BC_PATH)/mipsel-linux-uclibc-gcc
STRIP_MIPS_KK_BC =	$(CC_MIPS_KK_BC_PATH)/sstrip

CC_MIPS_KK_AT_PATH =	/usr/src/openWrt/build/kamikaze-atheros-2.6/kamikaze/staging_dir_mips/bin
CC_MIPS_KK_AT =		$(CC_MIPS_KK_AT_PATH)/mips-linux-uclibc-gcc
STRIP_MIPS_KK_AT =	$(CC_MIPS_KK_AT_PATH)/sstrip

CC_MIPS_WR_PATH =	/usr/src/openWrt/build/whiterussian/openwrt/staging_dir_mipsel/bin
CC_MIPS_WR =		$(CC_MIPS_WR_PATH)/mipsel-linux-uclibc-gcc
STRIP_MIPS_WR =		$(CC_MIPS_WR_PATH)/sstrip

CC_ARM_OE_PATH =	/usr/src/openEmbedded/stuff/build/akita/tmp/cross/bin
CC_ARM_OE =		$(CC_ARM_OE_PATH)/arm-linux-gcc
STRIP_ARM_OE =		$(CC_ARM_OE_PATH)/arm-linux-strip

CC_N770_OE_PATH =	/usr/src/openEmbedded/stuff/build/nokia770/tmp/cross/bin
CC_N770_OE =		$(CC_N770_OE_PATH)/arm-linux-gcc
STRIP_N770_OE =		$(CC_N770_OE_PATH)/arm-linux-strip


IPKG_BUILD=		ln -f $(FILE_NAME) $(IPKG_BUILD_PATH)/ipkg-target/usr/sbin/$(BINARY_NAME) && \
			$(IPKG_BUILD_PATH)/ipkg-make-control.sh   $(IPKG_BUILD_PATH)/ipkg-target $(FILE_NAME).ipk  $(BINARY_NAME)  $(IPKG_VERSION)


LINK_AND_TAR=		tar czvf $(FILE_NAME).tgz $(FILE_NAME) && \
			ln -f $(FILE_NAME).tgz $(FILE_CURRENT).tgz && \
			ln -f $(FILE_NAME).ipk $(FILE_CURRENT).ipk && \
			ln -f $(FILE_NAME) $(FILE_CURRENT) && \
			mkdir -p dl/misc && \
			ln -f $(FILE_NAME)* dl/misc/ && \
			ln -f $(FILE_CURRENT)* dl/misc/

all:		$(BINARY_NAME)

$(BINARY_NAME):	$(LINUX_SRC_C) $(LINUX_SRC_H) Makefile
	$(CC) $(CFLAGS)  -o $@ $(LINUX_SRC_C) $(LDFLAGS)



long:	sources i386 mipsel-kk-bc mips-kk-at mipsel-wr arm-oe nokia770-oe clean-long

axel:	sources i386 mipsel-kk-bc mips-kk-at mipsel-wr arm-oe clean-long

sources:
	mkdir -p $(FILE_NAME)
	cp $(LINUX_SRC_H) $(LINUX_SRC_C) Makefile $(FILE_NAME)/
	$(BUILD_PATH)/wget --no-check-certificate -O changelog.html  https://dev.open-mesh.net/batman/log/$(LOG_BRANCH)/
	html2text -o changelog.txt -nobs -ascii changelog.html
	awk '/View revision/,/10\/01\/06 20:23:03/' changelog.txt > $(FILE_NAME)/CHANGELOG
	tar czvf $(FILE_NAME).tgz $(FILE_NAME)

	mkdir -p dl/misc
	ln -f $(FILE_NAME).tgz dl/misc/
	ln -f $(FILE_NAME).tgz dl/misc/$(FILE_CURRENT).tgz

	mkdir -p dl/sources
	ln -f $(FILE_NAME).tgz dl/sources/
	ln -f $(FILE_NAME).tgz dl/sources/$(FILE_CURRENT).tgz


i386: i386-gc-elf-32-lsb-static i386-gc-elf-32-lsb-dynamic

i386-gc-elf-32-lsb-static:	$(LINUX_SRC_C) $(LINUX_SRC_H) Makefile
	$(CC) $(CFLAGS) -DREVISION_VERSION=$(REVISION_VERSION) -o $(FILE_NAME) $(LINUX_SRC_C) $(LDFLAGS) -static
	$(STRIP) $(FILE_NAME)
	$(IPKG_BUILD) i386
	$(LINK_AND_TAR)

	mkdir -p dl/i386
	ln -f $(FILE_NAME).tgz dl/i386/
	ln -f $(FILE_CURRENT).tgz dl/i386/


i386-gc-elf-32-lsb-dynamic:	$(LINUX_SRC_C) $(LINUX_SRC_H) Makefile
	$(CC) $(CFLAGS) -DREVISION_VERSION=$(REVISION_VERSION) -o $(FILE_NAME) $(LINUX_SRC_C) $(LDFLAGS)
	$(STRIP) $(FILE_NAME)
	$(IPKG_BUILD) i386
	$(LINK_AND_TAR)

	mkdir -p dl/i386
	ln -f $(FILE_NAME) batmand
	ln -f $(FILE_NAME).tgz dl/i386/
	ln -f $(FILE_CURRENT).tgz dl/i386/



mipsel-kk-bc:	mipsel-kk-elf-32-lsb-static mipsel-kk-elf-32-lsb-dynamic

mipsel-kk-elf-32-lsb-static:	$(LINUX_SRC_C) $(LINUX_SRC_H) Makefile
	$(CC_MIPS_KK_BC) $(CFLAGS_MIPS) -DREVISION_VERSION=$(REVISION_VERSION) -o $(FILE_NAME) $(LINUX_SRC_C) $(LDFLAGS_MIPS) -static
	$(STRIP_MIPS_KK_BC) $(FILE_NAME)
	$(IPKG_BUILD) mipsel
	$(LINK_AND_TAR)

	mkdir -p dl/meshcube
	ln -f $(FILE_NAME).ipk dl/meshcube/
	ln -f $(FILE_CURRENT).ipk dl/meshcube/


mipsel-kk-elf-32-lsb-dynamic:	$(LINUX_SRC_C) $(LINUX_SRC_H) Makefile
	$(CC_MIPS_KK_BC) $(CFLAGS_MIPS) -DREVISION_VERSION=$(REVISION_VERSION) -o $(FILE_NAME) $(LINUX_SRC_C) $(LDFLAGS_MIPS)
	$(STRIP_MIPS_KK_BC) $(FILE_NAME)
	$(IPKG_BUILD) mipsel $(IPKG_DEPENDS)
	$(LINK_AND_TAR)

	mkdir -p dl/netgear-kamikaze
	ln -f $(FILE_NAME).ipk dl/netgear-kamikaze/
	ln -f $(FILE_CURRENT).ipk dl/netgear-kamikaze/


mips-kk-at:	mips-kk-elf-32-msb-static mips-kk-elf-32-msb-dynamic

mips-kk-elf-32-msb-static:	$(LINUX_SRC_C) $(LINUX_SRC_H) Makefile
	$(CC_MIPS_KK_AT) $(CFLAGS_MIPS) -DREVISION_VERSION=$(REVISION_VERSION) -o $(FILE_NAME) $(LINUX_SRC_C) $(LDFLAGS_MIPS) -static
	$(STRIP_MIPS_KK_AT) $(FILE_NAME)
	$(IPKG_BUILD) mips
	$(LINK_AND_TAR)

	mkdir -p dl/fonera
	ln -f $(FILE_NAME).tgz dl/fonera/
	ln -f $(FILE_CURRENT).tgz dl/fonera/


mips-kk-elf-32-msb-dynamic:	$(LINUX_SRC_C) $(LINUX_SRC_H) Makefile
	$(CC_MIPS_KK_AT) $(CFLAGS_MIPS) -DREVISION_VERSION=$(REVISION_VERSION) -o $(FILE_NAME) $(LINUX_SRC_C) $(LDFLAGS_MIPS)
	$(STRIP_MIPS_KK_AT) $(FILE_NAME)
	$(IPKG_BUILD) mips $(IPKG_DEPENDS)
	$(LINK_AND_TAR)

	mkdir -p dl/fonera-kamikaze
	ln -f $(FILE_NAME).ipk dl/fonera-kamikaze/
	ln -f $(FILE_CURRENT).ipk dl/fonera-kamikaze/


mipsel-wr:	mipsel-wr-elf-32-lsb-static mipsel-wr-elf-32-lsb-dynamic

mipsel-wr-elf-32-lsb-static:	$(LINUX_SRC_C) $(LINUX_SRC_H) Makefile
	$(CC_MIPS_WR) $(CFLAGS_MIPS) -DREVISION_VERSION=$(REVISION_VERSION) -o $(FILE_NAME) $(LINUX_SRC_C) $(LDFLAGS_MIPS) -static
	$(STRIP_MIPS_WR) $(FILE_NAME)
	$(IPKG_BUILD) mipsel
	$(LINK_AND_TAR)

mipsel-wr-elf-32-lsb-dynamic:	$(LINUX_SRC_C) $(LINUX_SRC_H) Makefile
	$(CC_MIPS_WR) $(CFLAGS_MIPS) -DREVISION_VERSION=$(REVISION_VERSION) -o $(FILE_NAME) $(LINUX_SRC_C) $(LDFLAGS_MIPS)
	$(STRIP_MIPS_WR) $(FILE_NAME)
	$(IPKG_BUILD) mipsel $(IPKG_DEPENDS)
	$(LINK_AND_TAR)

	mkdir -p dl/wrt-freifunk
	ln -f $(FILE_NAME).ipk dl/wrt-freifunk/
	ln -f $(FILE_CURRENT).ipk dl/wrt-freifunk/
	mkdir -p dl/buffalo-freifunk
	ln -f $(FILE_NAME).ipk dl/buffalo-freifunk/
	ln -f $(FILE_CURRENT).ipk dl/buffalo-freifunk/

arm-oe:		armv5te-oe-elf-32-lsb-static armv5te-oe-elf-32-lsb-dynamic 

armv5te-oe-elf-32-lsb-static:	$(LINUX_SRC_C) $(LINUX_SRC_H) Makefile
	$(CC_ARM_OE) $(CFLAGS_MIPS) -DREVISION_VERSION=$(REVISION_VERSION) -o $(FILE_NAME) $(LINUX_SRC_C) $(LDFLAGS_MIPS) -static
	$(STRIP_ARM_OE) $(FILE_NAME)
	$(IPKG_BUILD) armv5te
	$(LINK_AND_TAR)	

	mkdir -p dl/armv5te
	ln -f $(FILE_NAME).ipk dl/armv5te/
	ln -f $(FILE_NAME).tgz dl/armv5te/
	ln -f $(FILE_CURRENT).ipk dl/armv5te/
	ln -f $(FILE_CURRENT).tgz dl/armv5te/

armv5te-oe-elf-32-lsb-dynamic:	$(LINUX_SRC_C) $(LINUX_SRC_H) Makefile
	$(CC_ARM_OE) $(CFLAGS_MIPS) -DREVISION_VERSION=$(REVISION_VERSION) -o $(FILE_NAME) $(LINUX_SRC_C) $(LDFLAGS_MIPS)
	$(STRIP_ARM_OE) $(FILE_NAME)
	$(IPKG_BUILD) armv5te kernel-module-tun
	$(LINK_AND_TAR)	

	mkdir -p dl/zaurus-akita
	ln -f $(FILE_NAME).ipk dl/zaurus-akita/
	ln -f $(FILE_CURRENT).ipk dl/zaurus-akita/

nokia770-oe:	nokia770-oe-elf-32-lsb-static nokia770-oe-elf-32-lsb-dynamic

nokia770-oe-elf-32-lsb-static:	$(LINUX_SRC_C) $(LINUX_SRC_H) Makefile
	$(CC_N770_OE) $(CFLAGS_MIPS) -DREVISION_VERSION=$(REVISION_VERSION) -o $(FILE_NAME) $(LINUX_SRC_C) $(LDFLAGS_MIPS) -static
	$(STRIP_N770_OE) $(FILE_NAME)
	$(IPKG_BUILD) arm-nokia770
	$(LINK_AND_TAR)	

nokia770-oe-elf-32-lsb-dynamic:	$(LINUX_SRC_C) $(LINUX_SRC_H) Makefile
	$(CC_N770_OE) $(CFLAGS_MIPS) -DREVISION_VERSION=$(REVISION_VERSION) -o $(FILE_NAME) $(LINUX_SRC_C) $(LDFLAGS_MIPS)
	$(STRIP_N770_OE) $(FILE_NAME)
	$(IPKG_BUILD) arm-nokia770 kernel-module-tun
	$(LINK_AND_TAR)	

clean:
		rm -f batmand *.o


clean-long:
		rm -rf batmand_*

## batmand 0.3

=== Makefile ===
#
# Copyright (C) 2006-2008 BATMAN contributors
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of version 2 of the GNU General Public
# License as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA
#


CC =		gcc
CFLAGS =	-Wall -O1 -g3
EXTRA_CFLAGS =	-DDEBUG_MALLOC -DMEMORY_USAGE -DPROFILE_DATA -DREVISION_VERSION=$(REVISION_VERSION)
LDFLAGS =	-lpthread

SBINDIR =	$(INSTALL_PREFIX)/usr/sbin

UNAME=		$(shell uname)
POSIX_C=	posix/init.c posix/posix.c posix/tunnel.c posix/unix_socket.c
BSD_C=		bsd/route.c bsd/tun.c bsd/kernel.c bsd/compat.c

ifeq ($(UNAME),Linux)
OS_C=		linux/route.c linux/tun.c linux/kernel.c $(POSIX_C)
endif

ifeq ($(UNAME),Darwin)
OS_C=		$(BSD_C) $(POSIX_C)
endif

ifeq ($(UNAME),FreeBSD)
OS_C=		$(BSD_C) $(POSIX_C)
endif

ifeq ($(UNAME),OpenBSD)
OS_C=		$(BSD_C) $(POSIX_C)
endif

LOG_BRANCH=	trunk/batman

SRC_FILES=	"\(\.c\)\|\(\.h\)\|\(Makefile\)\|\(INSTALL\)\|\(LIESMICH\)\|\(README\)\|\(THANKS\)\|\(TRASH\)\|\(Doxyfile\)\|\(./posix\)\|\(./linux\)\|\(./bsd\)\|\(./man\)\|\(./doc\)"

SRC_C=		batman.c originator.c schedule.c list-batman.c allocate.c bitarray.c hash.c profile.c ring_buffer.c $(OS_C)
SRC_H=		batman.h originator.h schedule.h list-batman.h os.h allocate.h bitarray.h hash.h profile.h vis-types.h ring_buffer.h
SRC_O=		$(SRC_C:.c=.o)

PACKAGE_NAME=	batmand
BINARY_NAME=	batmand
SOURCE_VERSION_HEADER= batman.h

REVISION_VERSION=\"\"

BAT_VERSION=	$(shell grep "^\#define SOURCE_VERSION " $(SOURCE_VERSION_HEADER) | sed -e '1p' -n | awk -F '"' '{print $$2}' | awk '{print $$1}')
FILE_NAME=	$(PACKAGE_NAME)_$(BAT_VERSION)-rv$(REVISION)_$@
NUM_CPUS = $(shell NUM_CPUS=`cat /proc/cpuinfo | grep -v 'model name' | grep processor | tail -1 | awk -F' ' '{print $$3}'`;echo `expr $$NUM_CPUS + 1`)


all:
	$(MAKE) -j $(NUM_CPUS) $(BINARY_NAME)

$(BINARY_NAME):	$(SRC_O) $(SRC_H) Makefile
	$(CC) -o $@ $(SRC_O) $(LDFLAGS)

%.o: %.c %.h
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) -c $< -o $@

%.o: %.c
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) -c $< -o $@

sources:
	mkdir -p $(FILE_NAME)

	for i in $$( find . | grep $(SRC_FILES) | grep -v "\.svn" ); do [ -d $$i ] && mkdir -p $(FILE_NAME)/$$i ; [ -f $$i ] && cp -Lvp $$i $(FILE_NAME)/$$i ;done

	wget --no-check-certificate -O changelog.html  https://dev.open-mesh.net/batman/log/$(LOG_BRANCH)/
	html2text -o changelog.txt -nobs -ascii changelog.html
	awk '/View revision/,/10\/01\/06 20:23:03/' changelog.txt > $(FILE_NAME)/CHANGELOG

	for i in $$( find man |	grep -v "\.svn" ); do [ -f $$i ] && groff -man -Thtml $$i > $(FILE_NAME)/$$i.html ;done

	tar czvf $(FILE_NAME).tgz $(FILE_NAME)

clean:
	rm -f $(BINARY_NAME) *.o posix/*.o linux/*.o bsd/*.o


clean-long:
	rm -rf $(PACKAGE_NAME)_*

install:
	mkdir -p $(SBINDIR)
	install -m 0755 $(BINARY_NAME) $(SBINDIR)

=== linux/modules/Makefile ===
UNAME:=$(shell uname -r)
LINUX26=2.6
LINUX_VERSION:=$(findstring $(LINUX26),$(UNAME))
REVISION := "0.3"	
include $(PWD)/Makefile.kbuild

ifneq ($(LINUX_VERSION),$(LINUX26))
TARGET:=batgat
INCLUDE:=-I/lib/modules/$(UNAME)/build/include -I/usr/src/kernel-headers-$(UNAME)/include
EXTRA_CFLAGS+=-D__KERNEL__ -DMODULE -O2 -Wall $(INCLUDE)
CC:=gcc
endif

ifeq ($(LINUX_VERSION),$(LINUX26))

all:
	make -C /lib/modules/$(shell uname -r)/build REVISION=$(REVISION) M=$(PWD) modules

clean:
	make -C /lib/modules/$(shell uname -r)/build M=$(PWD) clean
else

clean:
	rm -f *.o *~
endif

## batmand 0.3.2

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2006-2008 BATMAN contributors
+# Copyright (C) 2006-2009 B.A.T.M.A.N. contributors
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of version 2 of the GNU General Public
@@ -16,11 +16,22 @@
 # 02110-1301, USA
 #
 
+ifneq ($(findstring $(MAKEFLAGS),s),s)
+ifndef V
+	Q_CC = @echo '   ' CC $@;
+	Q_LD = @echo '   ' LD $@;
+	export Q_CC
+	export Q_LD
+endif
+endif
+
+# activate this variable to deactivate policy routing for backward compatibility
+#NO_POLICY_ROUTING = -DNO_POLICY_ROUTING
 
 CC =		gcc
-CFLAGS =	-Wall -O1 -g3
-EXTRA_CFLAGS =	-DDEBUG_MALLOC -DMEMORY_USAGE -DPROFILE_DATA -DREVISION_VERSION=$(REVISION_VERSION)
-LDFLAGS =	-lpthread
+CFLAGS +=	-pedantic -Wall -W -O1 -g3 -std=gnu99
+EXTRA_CFLAGS =	-DDEBUG_MALLOC -DMEMORY_USAGE -DPROFILE_DATA $(NO_POLICY_ROUTING) -DREVISION_VERSION=$(REVISION_VERSION)
+LDFLAGS +=	-lpthread
 
 SBINDIR =	$(INSTALL_PREFIX)/usr/sbin
 
@@ -36,6 +47,11 @@
 OS_C=		$(BSD_C) $(POSIX_C)
 endif
 
+ifeq ($(UNAME),GNU/kFreeBSD)
+OS_C=		$(BSD_C) $(POSIX_C)
+LDFLAGS+=	-lfreebsd -lbsd
+endif
+
 ifeq ($(UNAME),FreeBSD)
 OS_C=		$(BSD_C) $(POSIX_C)
 endif
@@ -48,15 +64,16 @@
 
 SRC_FILES=	"\(\.c\)\|\(\.h\)\|\(Makefile\)\|\(INSTALL\)\|\(LIESMICH\)\|\(README\)\|\(THANKS\)\|\(TRASH\)\|\(Doxyfile\)\|\(./posix\)\|\(./linux\)\|\(./bsd\)\|\(./man\)\|\(./doc\)"
 
-SRC_C=		batman.c originator.c schedule.c list-batman.c allocate.c bitarray.c hash.c profile.c ring_buffer.c $(OS_C)
-SRC_H=		batman.h originator.h schedule.h list-batman.h os.h allocate.h bitarray.h hash.h profile.h vis-types.h ring_buffer.h
-SRC_O=		$(SRC_C:.c=.o)
+SRC_C= batman.c originator.c schedule.c list-batman.c allocate.c bitarray.c hash.c profile.c ring_buffer.c hna.c $(OS_C)
+SRC_H= batman.h originator.h schedule.h list-batman.h os.h allocate.h bitarray.h hash.h profile.h vis-types.h ring_buffer.h hna.h
+SRC_O= $(SRC_C:.c=.o)
 
 PACKAGE_NAME=	batmand
 BINARY_NAME=	batmand
 SOURCE_VERSION_HEADER= batman.h
 
-REVISION_VERSION=\"\"
+REVISION:=	$(shell if [ -d .svn ]; then svn info | grep "Rev:" | sed -e '1p' -n | awk '{print $$4}'; else if [ -d ~/.svk ]; then echo $$(svk info | grep "Mirrored From" | awk '{print $$5}'); fi; fi)
+REVISION_VERSION=\"\ rv$(REVISION)\"
 
 BAT_VERSION=	$(shell grep "^\#define SOURCE_VERSION " $(SOURCE_VERSION_HEADER) | sed -e '1p' -n | awk -F '"' '{print $$2}' | awk '{print $$1}')
 FILE_NAME=	$(PACKAGE_NAME)_$(BAT_VERSION)-rv$(REVISION)_$@
@@ -67,20 +84,18 @@
 	$(MAKE) -j $(NUM_CPUS) $(BINARY_NAME)
 
 $(BINARY_NAME):	$(SRC_O) $(SRC_H) Makefile
-	$(CC) -o $@ $(SRC_O) $(LDFLAGS)
+	$(Q_LD)$(CC) -o $@ $(SRC_O) $(LDFLAGS)
 
-%.o: %.c %.h
-	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) -c $< -o $@
-
-%.o: %.c
-	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) -c $< -o $@
+.c.o:
+	$(Q_CC)$(CC) $(CFLAGS) $(EXTRA_CFLAGS) -MD -c $< -o $@
+-include $(SRC_C:.c=.d)
 
 sources:
 	mkdir -p $(FILE_NAME)
 
 	for i in $$( find . | grep $(SRC_FILES) | grep -v "\.svn" ); do [ -d $$i ] && mkdir -p $(FILE_NAME)/$$i ; [ -f $$i ] && cp -Lvp $$i $(FILE_NAME)/$$i ;done
 
-	wget --no-check-certificate -O changelog.html  https://dev.open-mesh.net/batman/log/$(LOG_BRANCH)/
+	wget -O changelog.html  http://www.open-mesh.net/log/$(LOG_BRANCH)/
 	html2text -o changelog.txt -nobs -ascii changelog.html
 	awk '/View revision/,/10\/01\/06 20:23:03/' changelog.txt > $(FILE_NAME)/CHANGELOG
 
@@ -90,6 +105,7 @@
 
 clean:
 	rm -f $(BINARY_NAME) *.o posix/*.o linux/*.o bsd/*.o
+	rm -f `find . -name '*.d' -print`
 
 
 clean-long:

=== linux/modules/Makefile ===
PWD:=$(shell pwd)
ifeq ($(wildcard $(KERNELPATH)),)
KERNELPATH = /lib/modules/$(shell uname -r)/build
# sanity check: does KERNELPATH exist?
ifeq ($(shell cd $(KERNELPATH) && pwd),)
$(error $(KERNELPATH) is missing, please set KERNELPATH)
endif
export KERNELPATH
endif


UNAME:=$(shell uname -r)
LINUX26=2.6
LINUX_VERSION:=$(findstring $(LINUX26),$(UNAME))
REVISION:=	$(shell if [ -d .svn ]; then \
						if which svn > /dev/null; then \
							svn info | grep "Rev:" | sed -e '1p' -n | awk '{print $$4}'; \
						else \
							echo "[unknown]"; \
						fi ; \
					else \
						if [ -d ~/.svk ]; then \
							if which svk > /dev/null; then \
								echo $$(svk info | grep "Mirrored From" | awk '{print $$5}'); \
							else \
								echo "[unknown]"; \
							fi; \
						fi; \
					fi)

include $(PWD)/Makefile.kbuild

ifneq ($(LINUX_VERSION),$(LINUX26))
TARGET:=batgat
INCLUDE:=-I/lib/modules/$(UNAME)/build/include -I/usr/src/kernel-headers-$(UNAME)/include
EXTRA_CFLAGS+=-D__KERNEL__ -DMODULE -O2 -Wall $(INCLUDE)
CC:=gcc
endif

ifeq ($(LINUX_VERSION),$(LINUX26))

all:
	$(MAKE) -C $(KERNELPATH) REVISION=$(REVISION) M=$(PWD) PWD=$(PWD) modules

clean:
	$(MAKE) -C $(KERNELPATH) M=$(PWD) PWD=$(PWD) clean
else

clean:
	rm -f *.o *~
endif

=== debian/changelog ===
batmand (0.3.2-6) unstable; urgency=low

  * debian/copyright: Update copyright years
  * Remove outdated README.source
  * Convert to 3.0 (quilt) source format
  * Use dh_dkms to provide DKMS support
  * debian/control:
    - Upgraded to policy 3.9.0, no changes required
    - Build only on linux due dependencies on the linux routing code

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Mon, 28 Jun 2010 22:43:59 +0200

batmand (0.3.2-5) unstable; urgency=low

  * Remove shlibs:Depends for binary packages without shared libs dependencies
  * Add missing ${misc:Depends} debhelper for batmand-gateway-source
  * Use dkms postinst script for batmand-gateway-dkms (Closes LP: #497149)
  * Correct spelling errors found by lintian

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Wed, 13 Jan 2010 23:32:26 +0100

batmand (0.3.2-4) unstable; urgency=low

  * Correct description of debian/patches/netdevice_ops.patch
  * Reformat debian/control
  * Provide batmand-gateway-dkms package that uses DKMS to dynamically build
    modules for the local kernel
  * Recommend either batmand-gateway-dkms or batmand-gateway-modules for batmand
    in debian/control

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Tue, 20 Oct 2009 17:19:15 +0200

batmand (0.3.2-3) unstable; urgency=low

  [ Sven Eckelmann ]
  * debian/patches:
    - Change to dep3 patch tagging guidelines
    - Remove number before patches as order is given by debian/patches/series
  * Remove inactive maintainer Wesley Tsai from Uploaders in debian/control
  * Override Lintian warning init.d-script-possible-missing-stop as sendsigs
    will kill the daemon more efficiently

  [ Petter Reinholdtsen ]
  * Correct runlevels and dependencies in init.d LSB header (Closes: #548306)
  * Add batmand.postinst to recover from incorrect init.d script headers in
    previous versions

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Sat, 03 Oct 2009 17:49:25 +0200

batmand (0.3.2-2) unstable; urgency=low

  * Upgraded to policy 3.8.3, no changes required
  * debian/patches:
    - Add 101-netdevice_ops.patch, fix compilation against linux-2.6.31
      (Closes: #534629)
  * Recommend batmand-gateway-modules and only suggest batmand-gateway-source
  * Add README.source with information about patch management

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Fri, 11 Sep 2009 01:06:25 +0200

batmand (0.3.2-1) unstable; urgency=low

  * New Upstream Version
  * Remove upstream merged batmand manpage
  * Remove olsr references from /etc/default/batmand
  * debian/patches:
    - Update 100-outoftree_kbuild.patch, only activate linux26 type of
      module building
  * debian/rules:
    - Use the kernel makefiles directly to build the module to match
      linux-modules-extra-2.6 way of building it
  * debian/control:
    - Add bzip2 Depend-Indep for batmand-gateway-source
    - Allow Debian Maintainers to upload new versions of batmand
  * Convert debian/copyright to new dep5 version

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Sat, 13 Jun 2009 08:49:10 +0200

batmand (0.3.1-3) unstable; urgency=low

  * Upgraded to policy 3.8.1, no changes required
  * Move batmand-gateway-* to new section kernel
  * Add package batmand-dbg with debug symbols
  * debian/control: Move Vcs-* to git.debian.org
  * Install kernel module source tarball to batmand-gateway.tar.bz2 instead of
    batmand-gateway-source.tar.bz2
  * Add quilt as patch system to debian/rules
  * debian/patches:
    - Add 100-outoftree-kbuild.patch - Allow out of tree module build for
      linux-modules-extra-2.6

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Fri, 10 Apr 2009 00:47:07 +0200

batmand (0.3.1-2) unstable; urgency=low

  * debian/copyright:
    - Correctly state that batmand is available under version 2 of the GPL
      only. Thanks to Frank Lichtenheld <ftpmaster@debian.org> for spotting
      this while reviewing NEW.

 -- Holger Levsen <holger@debian.org>  Thu, 26 Mar 2009 17:57:54 +0100

batmand (0.3.1-1) unstable; urgency=low

  [ Sven Eckelmann ]
  * New upstream release.
  * Generate package for B.A.T.M.A.N. gateway linux kernel module
  * debian/rules:
    - Let dh_clean (>= 7) delete top level *-stamp files
    - Replace deprecated dh_clean -k with dh_prep
    - Remove unused configure target
    - Run debhelper in binary-arch only for arch dependent targets
    - Use CFLAGS from dpkg-buildpackage
  * debian/control:
    - Correct Upstream URL
    - Add myself as uploader
    - Recommend batmand by batmand-gateway-(source|modules)
  * debian/copyright:
    - Convert copyright to new machine readable copyright format
    - Update copyright years
    - Remove list.h as special copyright case due to removal
    - Add new copyright holders Antoine van Gelder and myself
  * Correct URLs to documents in upstream
  * Correct URL in debian/watch to match newer releases

  [ Holger Levsen ]
  * Gladly accept the patches by Sven :-)
  * debian/control: batmand-gateway-modules can only be a suggests,
    -source is recommended.
  * debian/copyright: add small paragraphs about the rights granted by the GPL. 

 -- Holger Levsen <holger@debian.org>  Sat, 14 Mar 2009 17:04:43 +0100

batmand (0.3-3) unstable; urgency=low

  * Replace looping maintainer address batmand@packages.d.o with mine.

 -- Holger Levsen <holger@debian.org>  Sat, 29 Nov 2008 18:54:54 +0000

batmand (0.3-2) unstable; urgency=low

  * The thanks to Sven Eckelmann release! (All patches in this upload where
    provided by him, I just wrote this changelog :-)
  * Bump standards version to 3.8.0, no changes needed, added breaks to
    Uploaders: anyway. (Closes: #497158)
  * batmand.8: turn minus signs into hyphens, or escape them properly. 
    (Closes: #497159)
  * Add a watch file. (Closes: #497157)

 -- Holger Levsen <holger@debian.org>  Sat, 25 Oct 2008 15:11:56 +0200

batmand (0.3-1) unstable; urgency=low

  * New upstream version.
  * Remove debian/patches and build-dependency on dpatch
  * Change maintainer email address.



=== debian/control ===
Source: batmand
Section: net
Priority: extra
Maintainer:  Holger Levsen <holger@debian.org>
Uploaders: Sven Eckelmann <sven.eckelmann@gmx.de>
Dm-Upload-Allowed: yes
Build-Depends: debhelper (>= 7), dkms (>= 2.1.1.1-2)
Build-Depends-Indep: bzip2
Standards-Version: 3.9.0
Homepage: http://www.open-mesh.net/
Vcs-Git: git://git.debian.org/git/collab-maint/batmand.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/batmand.git

Package: batmand
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: batmand-gateway-source
Recommends: batmand-gateway-dkms (>= ${source:Version})
 | batmand-gateway-modules
Description: better approach to mobile adhoc networking
 B.A.T.M.A.N. (better approach to mobile ad-hoc networking) is a new routing
 protocol for multi-hop ad-hoc mesh networks.
 .
 The approach of the B.A.T.M.A.N algorithm is to divide the knowledge about the
 best end-to-end paths between nodes in the mesh to all participating nodes.
 Each node perceives and maintains only the information about the best next hop
 towards all other nodes. Thereby the need for a global knowledge about local
 topology changes becomes unnecessary. Additionally, an event-based but timeless
 flooding mechanism prevents the accruement of contradicting topology
 information and limits the amount of topology messages flooding the mesh. The
 algorithm is designed to deal with networks that are based on unreliable links.

Package: batmand-dbg
Section: debug
Architecture: linux-any
Depends: ${misc:Depends}, batmand (= ${binary:Version})
Description: better approach to mobile adhoc networking (debug files)
 B.A.T.M.A.N. (better approach to mobile ad-hoc networking) is a new routing
 protocol for multi-hop ad-hoc mesh networks.
 .
 This package contains the debug files.

Package: batmand-gateway-source
Section: kernel
Architecture: all
Depends: ${misc:Depends}, module-assistant, debhelper (>= 7), make, bzip2, quilt
Recommends: batmand
Description: Source for the batmand-gateway kernel module
 This package provides the source code for the batmand-gateway-source kernel
 modules. It is used to reduce the load of a batmand gateway by moving all
 tunnel related operations from userspace to kernelland and thus minimize memory
 operations between them. batmand doesn't require the gateway to be loaded to
 provide gateway functionality. Kernel source or headers are required to compile
 these modules.
 .
 This package is part of batmand. See batmand package for more information.

Package: batmand-gateway-dkms
Section: kernel
Architecture: all
Depends: ${misc:Depends}
Recommends: batmand
Description: DKMS Source for the batmand-gateway kernel module
 This package provides the source code for the batmand-gateway-source kernel
 modules, packaged with approriate configuration for DKMS to build new modules
 dynamically. It is used to reduce the load of a batmand gateway by moving all
 tunnel related operations from userspace to kernelland and thus minimize memory
 operations between them. batmand doesn't require the gateway to be loaded to
 provide gateway functionality. Kernel source or headers are required to compile
 these modules.
 .
 This package is part of batmand. See batmand package for more information.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

INSTALL=/usr/bin/install
psource:=batmand-gateway-source
dkmssource:=batmand-gateway-dkms
sname:=batmand-gateway

version:= $(shell dpkg-parsechangelog | grep ^Version: | cut -d' ' -f2 \
            | cut -d- -f1)

### KERNEL SETUP
### Setup the stuff needed for making kernel module packages
### taken from /usr/share/kernel-package/sample.module.rules

PACKAGE=batmand-gateway-modules
MA_DIR=/usr/share/modass
-include $(MA_DIR)/include/generic.make
-include $(MA_DIR)/include/common-rules.make

kdist_config: prep-deb-files

# the kdist_clean target is called by make-kpkg modules_clean and from
# kdist* rules. It is responsible for cleaning up any changes that have
# been made by the other kdist_commands (except for the .deb files created)
#kdist_clean: clean
kdist_clean:
	$(MAKE) $(MFLAGS) -f debian/rules clean
	$(MAKE) -C $(KSRC) M=$(CURDIR) clean

### end  KERNEL SETUP

k = $(shell echo $(KVERS) | grep -q ^2.6 && echo k)

binary-modules: binary-modules-stamp
	dh_testdir

# the binary-modules rule is invoked by module-assistant while processing the
# kdist* targets. It is called by module-assistant or make-kpkg and *not*
# during a normal build
binary-modules-stamp:
	dh_testroot
	dh_prep
	dh_installdirs lib/modules/$(KVERS)/kernel/net

	# Build the module
	$(MAKE) -C $(KSRC) M=$(CURDIR)

	# Install the module
	cp batgat.$ko debian/$(PKGNAME)/lib/modules/$(KVERS)/kernel/net

	dh_installdocs
	dh_installchangelogs
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol -- -v$(VERSION)
	dh_md5sums
	dh_builddeb --destdir=$(DEB_DESTDIR)
	dh_prep
	touch $@

build: build-stamp

build-stamp:
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE) CFLAGS="$(CFLAGS)"
	#docbook-to-man debian/batmand.sgml > batmand.1

	touch $@

clean:
	dh_testdir
	dh_testroot

	# Add here commands to clean up after the build process.
	# clean can be run from module assistant or the original package rules file.
	if [ ! -r mod_batman.c ]; then \
		$(MAKE) clean; \
	fi

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	# Add here commands to install the package into debian/batmand.
	$(MAKE) INSTALL_PREFIX=$(CURDIR)/debian/batmand install
	$(INSTALL) -m 0644 -D  $(CURDIR)/debian/batmand-default $(CURDIR)/debian/batmand/etc/default/batmand

	# Create the directories to install the source into
	dh_installdirs -p$(psource)  usr/src/modules/$(sname)/debian
	dh_installdirs -p$(dkmssource)  usr/src/$(sname)-$(version)

	# Copy only the driver source to the proper location
	cp linux/modules/*.c linux/modules/*.h linux/modules/Makefile*  \
		debian/$(psource)/usr/src/modules/$(sname)
	cp linux/modules/*.c linux/modules/*.h linux/modules/Makefile*  \
		debian/$(dkmssource)/usr/src/$(sname)-$(version)
	mv debian/$(psource)/usr/src/modules/$(sname)/Makefile.kbuild \
	   debian/$(psource)/usr/src/modules/$(sname)/Makefile
	mv debian/$(dkmssource)/usr/src/$(sname)-$(version)/Makefile.kbuild \
	   debian/$(dkmssource)/usr/src/$(sname)-$(version)/Makefile
	# Copy the needed debian/ pieces to the proper location
	cp debian/*modules.in* \
		debian/$(psource)/usr/src/modules/$(sname)/debian
	cp debian/changelog debian/copyright debian/rules\
		debian/compat debian/control debian/$(psource)/usr/src/modules/$(sname)/debian/

	mkdir -p debian/$(psource)/usr/share/doc/$(psource)
	cp debian/copyright debian/$(psource)/usr/share/doc/$(psource)
	mkdir -p debian/$(dkmssource)/usr/share/doc/$(dkmssource)
	cp debian/copyright debian/$(dkmssource)/usr/share/doc/$(dkmssource)

	mkdir -p debian/$(psource)$(MA_DIR)/packages/
	cd debian/$(psource)$(MA_DIR)/packages/ && ln -sf default.sh $(psource)
	cd debian/$(psource)/usr/src && tar c modules | bzip2 -9 > $(sname).tar.bz2 && rm -rf modules

	dh_dkms -V
	dh_install


# Build architecture-independent files here.
binary-indep: build install
	dh_testdir -i
	dh_testroot -i
	dh_installchangelogs  -i
	dh_installman -i
	dh_link -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -s
	dh_testroot -s
	dh_installchangelogs -s CHANGELOG
	dh_installdocs -s
	dh_installexamples -s
	dh_lintian -s
#	dh_install -s
	dh_installinit -s -u"start 20 2 3 4 5 . stop 20 1 ."
	dh_installman -s
	dh_link -s
	dh_strip -s --dbg-package=batmand-dbg
	dh_compress -s
	dh_fixperms -s
	dh_installdeb -s
	dh_shlibdeps -s
	dh_gencontrol -s
	dh_md5sums -s
	dh_builddeb -s

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install binary-modules kdist kdist_clean

=== debian/watch ===
version=3
opts="uversionmangle=s/-(alpha|beta|rc)/~$1/" \
 http://downloads.open-mesh.net/batman/stable/sources/batman/batman-(.*).tar.gz

## batmand 0.3.2+51+g1e275d9

=== Makefile ===
#!/usr/bin/make -f
# -*- makefile -*-
#
# Copyright (C) 2006-2012 B.A.T.M.A.N. contributors
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of version 2 of the GNU General Public
# License as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA
#

# batmand build
BINARY_NAME = batmand

UNAME =		$(shell uname)
POSIX_OBJ =	posix/init.o posix/posix.o posix/tunnel.o posix/unix_socket.o
LINUX_OBJ =	linux/route.o linux/tun.o linux/kernel.o

ifeq ($(UNAME),Linux)
OS_OBJ =	$(LINUX_OBJ) $(POSIX_OBJ)
CPPFLAGS +=	-D_GNU_SOURCE
endif

OBJ = batman.o originator.o schedule.o list-batman.o allocate.o bitarray.o hash.o profile.o ring_buffer.o hna.o $(OS_OBJ)
MANPAGE = man/batmand.8

# activate this variable to deactivate policy routing for backward compatibility
#NO_POLICY_ROUTING = -DNO_POLICY_ROUTING

# batmand flags and options
CFLAGS +=	-pedantic -Wall -W -std=gnu99 -MD
CPPFLAGS +=	-DDEBUG_MALLOC -DMEMORY_USAGE -DPROFILE_DATA $(NO_POLICY_ROUTING)
LDLIBS +=	-lpthread

# disable verbose output
ifneq ($(findstring $(MAKEFLAGS),s),s)
ifndef V
	Q_CC = @echo '   ' CC $@;
	Q_LD = @echo '   ' LD $@;
	export Q_CC
	export Q_LD
endif
endif

# standard build tools
CC ?=		gcc
RM ?= rm -f
INSTALL ?= install
MKDIR ?= mkdir -p
COMPILE.c = $(Q_CC)$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
LINK.o = $(Q_LD)$(CC) $(LDFLAGS) $(TARGET_ARCH)

# standard install paths
PREFIX = /usr/local
SBINDIR = $(PREFIX)/sbin
MANDIR = $(PREFIX)/share/man

# try to generate revision
REVISION= $(shell	if [ -d .git ]; then \
				echo $$(git describe --always --dirty --match "v*" |sed 's/^v//' 2> /dev/null || echo "[unknown]"); \
			fi)
ifneq ($(REVISION),)
CPPFLAGS += -DSOURCE_VERSION=\"$(REVISION)\"
endif

# default target
all: $(BINARY_NAME)

# standard build rules
.SUFFIXES: .o .c
.c.o:
	$(COMPILE.c) -o $@ $<

$(BINARY_NAME): $(OBJ)
	$(LINK.o) $^ $(LDLIBS) -o $@

clean:
	$(RM) $(BINARY_NAME) $(OBJ) $(DEP)

install: $(BINARY_NAME)
	$(MKDIR) $(DESTDIR)$(SBINDIR)
	$(MKDIR) $(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -m 0755 $(BINARY_NAME) $(DESTDIR)$(SBINDIR)
	$(INSTALL) -m 0644 $(MANPAGE) $(DESTDIR)$(MANDIR)/man8

# load dependencies
DEP = $(OBJ:.o=.d)
-include $(DEP)

.PHONY: all clean install

## batmand 0.3.2+72+ga83038a

=== debian/changelog ===
batmand (0.3.2+72+ga83038a-4) experimental; urgency=medium

  * debian/control:
    - Automatically select correct Vcs-Git branch
    - Move Vcs to communitywlan-team group

 -- Sven Eckelmann <sven@narfation.org>  Sun, 28 Jul 2019 11:50:46 +0200

batmand (0.3.2+72+ga83038a-3) experimental; urgency=medium

  * debian/control
    - Upgraded to policy 4.3.0, no changes required
    - Switch to debhelper 12
  * debian/copyright
    - Update copyright years to 2019

 -- Sven Eckelmann <sven@narfation.org>  Sat, 02 Mar 2019 20:16:51 +0100

batmand (0.3.2+72+ga83038a-2) experimental; urgency=medium

  * Merge changes from batmand 0.3.2-18

 -- Sven Eckelmann <sven@narfation.org>  Fri, 19 Oct 2018 18:46:31 +0200

batmand (0.3.2+72+ga83038a-1) experimental; urgency=medium

  * New Upstream Snapshot from a83038a5a21e18791817b354d64e6fe443bb0564

 -- Sven Eckelmann <sven@narfation.org>  Sun, 31 Jan 2016 18:32:43 +0100

batmand (0.3.2+71+g036aea1-1) experimental; urgency=medium

  * New Upstream Snapshot from 036aea1fe69d275aecae64cc643e8e34fac550a0
  * debian/patches:
    - Rebase nodetach.patch on top of 0.3.2+51+g1e275d9
    - Rebase hash_resize_leak.patch on top of 0.3.2+51+g1e275d9
    - Remove upstream merged linker-flags.patch and
      no_unchecked_binary_execute.patch
    - Remove upstream merged ansi_clear.patch, bitarry_shift.patch,
      cflags_linker.patch, const_assignment.patch,
      dependency_debugmalloc_memoryusage.patch, dereference_before_check.patch,
      hash_resize_leak.patch, include_guards.patch, includes.patch,
      make_header_depends.patch, preprocessor_debug_level.patch,
      preprocessor_policy_routing.patch, printf_fixup.patch,
      schedule_packet_null.patch, setsockopt_leak.patch, standard_daemon.patch,
      strict-aliasing.patch, unused_parameter.patch

 -- Sven Eckelmann <sven@narfation.org>  Fri, 01 Aug 2014 23:52:09 +0200

batmand (0.3.2+51+g1e275d9-1) experimental; urgency=low

  * New Upstream Snapshot from 1e275d939d45ecc1d96957a353dc639d28aefb52
  * debian/patches:
    - Remove upstream merged define_gnu_source.patch, dead_links.patch and
      email_addresses.patch
    - Remove lto.patch, Replaced by cflags_linker.patch
    - Add cflags_linker.patch, Add CFLAGS to the linker step
    - Add make_header_depends.patch, Don't fail rebuild when header is removed
    - Add include_guards.patch, Add include guards to avoid redundant
      declarations or include loops
    - Add const_assignment.patch, Avoid assigning const buffer to non-const
      pointer
    - Add preprocessor_policy_routing.patch, Fix preprocessor check for defined
      NO_POLICY_ROUTING
    - Add printf_fixup.patch, Fix printf format strings
    - Add ansi_clear.patch, Clear screen using ANSI escape codes
    - Add standard_daemon.patch, Use POSIX daemon function instead of
      self-written one
    - Add includes.patch, Add missing includes and remove unused includes
    - Add unused_parameter.patch, Mark unused parameter in dummy functions
    - Add preprocessor_debug_level.patch, Fix preprocessor check for defined
      DEBUG_MALLOC && MEMORY_USAGE
    - Add dependency_debugmalloc_memoryusage.patch, Add error for
      MEMORY_USAGE dependency
  * debian/rules:
    - Remove unused make option LTO=1
    - Add -flto to DEB_CFLAGS_MAINT_APPEND to replace lto.patch

 -- Sven Eckelmann <sven@narfation.org>  Thu, 12 Sep 2013 22:42:29 +0200

batmand (0.3.2+50+g06537ed-1) experimental; urgency=low

  * New Upstream Snapshot from 06537edb55ac494709a6351e0f25555d2f58e9bc
  * debian/patches:
    - Remove upstream merged build_rules.patch, ftbfs_secondbuild.patch,
      install_manpage.patch, man_spelling_errors.patch,
      non_parallel_build.patch, version_info.patch
  * Update debian/copyright

 -- Sven Eckelmann <sven@narfation.org>  Sat, 16 Jun 2012 23:23:59 +0200

batmand (0.3.2-20) unstable; urgency=medium

  * debian/control:
    - Add Pre-Depends for --skip-systemd-native invoke-rc.d
    - Drop unused lsb-base dependency

 -- Sven Eckelmann <sven@narfation.org>  Sun, 28 Jul 2019 11:47:48 +0200

batmand (0.3.2-19) unstable; urgency=medium

  * debian/copyright:
    - Update copyright year
  * Update to debhelper to 12
  * debian/control:
    - Move Vcs to communitywlan-team group
  * Upgraded to policy 4.4.0, no changes required

 -- Sven Eckelmann <sven@narfation.org>  Sun, 21 Jul 2019 13:10:16 +0200

batmand (0.3.2-18) unstable; urgency=medium

  * Upgraded to policy 4.2.1
    - Switch from priority extra to optional
    - remove get-orig-source rule from debian/rules
  * Download snapshots via https:// in debian/get-orig-source.sh
  * Reference repository only over https:// in debian/upstream/metadata
  * debian/copyright:
    - Update copyright years
  * debian/control:
    - update to debhelper 10
    - Move VCS-* to salsa.debian.org
  * debian/rules
    - Remove ddeb migration conflict against pre-stretch package
    - Drop (now default) parameter --parallel for dch
    - Remove unused INSTALL variable
    - Use pkg-info.mk to add the package version as internal batmand version

 -- Sven Eckelmann <sven@narfation.org>  Thu, 18 Oct 2018 19:27:29 +0200

batmand (0.3.2-17) unstable; urgency=medium

  * Update copyright years in debian/copyright
  * Replace Holger Levsen as maintainer of batmand (Closes: #809647)
  * debian/control
    - Change Vcs-Git and Vcs-Browser to https://
  * debian/upstream/signing-key.asc
    - Import new upstream RSA 4096 key 2DE9541A85CC87D5D9836D5E0C8A47A2ABD72DF9
  * Sort debian control files with `wrap-and-sort -abst`

 -- Sven Eckelmann <sven@narfation.org>  Sun, 31 Jan 2016 18:26:22 +0100

batmand (0.3.2-16) unstable; urgency=medium

  * Upgraded to policy 3.9.6, no changes required
  * Update years in debian/copyright
  * debian/patches:
    - Move patches to alternative DEP-3 format and manage them with gbp pq
  * debian/control, debian/rules:
    - Drop batmand-dbg in favor of -dbgsym package
  * debian/batmand.service


=== debian/control ===
Source: batmand
Section: net
Priority: optional
Maintainer: Sven Eckelmann <sven@narfation.org>
Standards-Version: 4.4.0
Homepage: https://www.open-mesh.org/
Vcs-Git: https://salsa.debian.org/communitywlan-team/batmand.git -b debian/experimental
Vcs-Browser: https://salsa.debian.org/communitywlan-team/batmand
Build-Depends:
 debhelper (>= 12),
 dpkg-dev (>= 1.16.1.1),

Package: batmand
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Depends:
 sysvinit-utils (>= 2.88dsf-50),
 ${misc:Depends},
 ${shlibs:Depends},
Description: better approach to mobile adhoc networking
 B.A.T.M.A.N. (better approach to mobile ad-hoc networking) is a new routing
 protocol for multi-hop ad-hoc mesh networks.
 .
 The approach of the B.A.T.M.A.N algorithm is to divide the knowledge about the
 best end-to-end paths between nodes in the mesh to all participating nodes.
 Each node perceives and maintains only the information about the best next hop
 towards all other nodes. Thereby the need for a global knowledge about local
 topology changes becomes unnecessary. Additionally, an event-based but timeless
 flooding mechanism prevents the accruement of contradicting topology
 information and limits the amount of topology messages flooding the mesh. The
 algorithm is designed to deal with networks that are based on unreliable links.

## batmand 0.3.2+74+g2f62b17

=== Makefile ===
--- 
+++ 
@@ -37,7 +37,7 @@
 #NO_POLICY_ROUTING = -DNO_POLICY_ROUTING
 
 # batmand flags and options
-CFLAGS +=	-pedantic -Wall -W -std=gnu99 -MD
+CFLAGS +=	-pedantic -Wall -W -std=gnu99 -MD -MP -fno-strict-aliasing
 CPPFLAGS +=	-DDEBUG_MALLOC -DMEMORY_USAGE -DPROFILE_DATA $(NO_POLICY_ROUTING)
 LDLIBS +=	-lpthread
 
@@ -57,7 +57,7 @@
 INSTALL ?= install
 MKDIR ?= mkdir -p
 COMPILE.c = $(Q_CC)$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
-LINK.o = $(Q_LD)$(CC) $(LDFLAGS) $(TARGET_ARCH)
+LINK.o = $(Q_LD)$(CC) $(CFLAGS) $(LDFLAGS) $(TARGET_ARCH)
 
 # standard install paths
 PREFIX = /usr/local

=== debian/changelog ===
batmand (0.3.2+74+g2f62b17-1) unstable; urgency=medium

  * Upload to unstable
  * New Upstream Snapshot from 2f62b17d4132f82c4716b672101eb7faa916192a
  * debian/control:
    - Upgraded to policy 4.6.2, no changes required

 -- Sven Eckelmann <sven@narfation.org>  Sat, 31 Dec 2022 20:00:56 +0100

batmand (0.3.2-23) UNRELEASED; urgency=medium

  * debian/control:
    - Upgraded to policy 4.6.2, no changes required

 -- Sven Eckelmann <sven@narfation.org>  Sat, 17 Dec 2022 11:42:20 +0100

batmand (0.3.2-22) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on dpkg-dev.
    + batmand: Drop versioned constraint on sysvinit-utils in Depends.

  [ Sven Eckelmann ]
  * debian/control:
    - Upgraded to policy 4.6.1, no changes required
    - Switch to correct DEP-14 unstable branch name
  * debian/copyright
    - Update copyright years to 2022

 -- Sven Eckelmann <sven@narfation.org>  Mon, 14 Nov 2022 18:08:10 +0100

batmand (0.3.2-21) unstable; urgency=medium

  * debian/control:
    - Switch debhelper dependency to debhelper-compat
    - Upgraded to policy 4.5.0, no changes required
    - Allow build without (fake)root
    - Switch to debhelper compat 13
    - Switch maintainer to Debian CommunityWLAN Team
  * debian/batmand.postinst:
    - Drop workaround for upgrades from 0.3.2-2
  * debian/copyright
    - Update copyright years to 2020
  * Drop duplicated fields from upstream/metadata
  * Update debian/watch for format 4

 -- Sven Eckelmann <sven@narfation.org>  Sun, 12 Jul 2020 11:48:11 +0200

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,21 @@
 Source: batmand
 Section: net
 Priority: optional
-Maintainer: Sven Eckelmann <sven@narfation.org>
-Standards-Version: 4.4.0
+Maintainer: Debian CommunityWLAN Team <team+communitywlan@tracker.debian.org>
+Uploaders:
+ Sven Eckelmann <sven@narfation.org>,
+Standards-Version: 4.6.2
+Rules-Requires-Root: no
 Homepage: https://www.open-mesh.org/
-Vcs-Git: https://salsa.debian.org/communitywlan-team/batmand.git -b debian/experimental
+Vcs-Git: https://salsa.debian.org/communitywlan-team/batmand.git -b debian/unstable
 Vcs-Browser: https://salsa.debian.org/communitywlan-team/batmand
 Build-Depends:
- debhelper (>= 12),
- dpkg-dev (>= 1.16.1.1),
+ debhelper-compat (= 13),
 
 Package: batmand
 Architecture: linux-any
 Pre-Depends: ${misc:Pre-Depends}
 Depends:
- sysvinit-utils (>= 2.88dsf-50),
  ${misc:Depends},
  ${shlibs:Depends},
 Description: better approach to mobile adhoc networking

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -fdata-sections -ffunction-sections -flto
export DEB_CPPFLAGS_MAINT_APPEND = -D_FILE_OFFSET_BITS=64
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--gc-sections

MAKEOPTIONS = V="1" REVISION="debian-$(DEB_VERSION)" PREFIX="/usr"

binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep:
	dh $@

override_dh_auto_build:
	dh_auto_build -- $(MAKEOPTIONS)

override_dh_auto_install:
	dh_auto_install -- $(MAKEOPTIONS)

.PHONY: binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep \
	override_dh_auto_build override_dh_auto_install

=== debian/watch ===
version=4
opts="uversionmangle=s/-(alpha|beta|rc)/~$1/,pgpsigurlmangle=s/$/.asc/" \
 https://downloads.open-mesh.org/batman/stable/sources/batmand/batmand-(.*).tar.gz
